# $Revision: 1.6 $, $Date: 2004/07/11 12:53:26 $
#
# Conditional build:
%bcond_with	flex_bison_c++	# use flex++/bison++
#
Summary:	A general, open source, retargetable decompiler of native executable files
Summary(pl):	Oglny, otwarty dekompilator natywnych plikw wykonywalnych
Name:		boomerang
Version:	0.0.0.20040708
Release:	0.2
License:	GPL
Group:		Development/Languages
Source0:	%{name}.tar.gz
# Source0-md5:	a9f15806eb670686869f67a06e8a6fbb
Patch0:		%{name}-path.patch
Patch1:		%{name}-types.patch
URL:		http://boomerang.sourceforge.net/
BuildRequires:	automake
%if %{with flex_bison_c++}
BuildRequires:	bison++
BuildRequires:	flex
%endif
BuildRequires:	cppunit-devel
BuildRequires:	expat-devel
BuildRequires:	gc-devel
BuildRequires:	libstdc++-devel
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		no_install_post_chrpath		1

%description
An attempt to develop a real decompiler through the open source
community. A decompiler takes as input an executable file, and
attempts to create a high level, compilable, even maintainable source
file that does the same thing. It is therefore the opposite of a
compiler, which of course takes a source file and makes an executable.
It won't of course recreate the original source file; probably nothing
like it. It does not matter if the executable file has symbols or not,
or was compiled from any particular language. (However, languages like
ML that are usually interpreted are not considered.)

The intent is to create a retargetable decompiler (i.e. one that can
work with different types of input executable files with modest
effort, e.g. X86-windows, sparc-solaris, etc). It will be highly
modular, so that different parts of the decompiler can be replaced
with experimental modules. It is intended to eventually become
interactive, a la IDA Pro, because some things (not just variable
names and comments, though these are obviously very important) require
expert intervention.

%description -l pl
Prba stworzenia prawdziwego dekompilatora przez spoeczno otwartego
oprogramowania. Dekompilator przyjmuje na wejciu plik wykonywalny i
prbuje stworzy kompilowalny, a nawet zarzdzalny, plik rdowy w
jzyku wyszego poziomu wykonujcy to samo zadanie. Jest to wic
przeciwiestwo kompilatora, ktry oczywicie przyjmuje plik rdowy i
tworzy wykonywalny. Oczywicie dekompilator nie odtworzy oryginalnego
pliku rdowego; raczej nic z tych rzeczy. Nie ma znaczenia, czy plik
wykonywalny ma symbole czy nie, ani czy zosta skompilowany z jakiego
konkretnego jzyka (jednak jzyki w rodzaju ML, ktre s zwykle
interpretowane, nie s brane pod uwag).

Intencj jest stworzenie dekompilatora dla wielu architektur (czyli
takiego, ktry moe dziaa z rnymi rodzajami wejciowych plikw
wykonywalnych z przyzwoitym efektem, np. x86-windows, sparc-solaris
itp.). Bdzie bardzo modularny, wic wiele czci dekompilatora moe
zosta zastpiona eksperymentalnymi moduami. By moe stanie si
interaktywny, jak IDA Pro, poniewa niektre rzeczy (nie tylko nazwy
zmiennych i komentarze, chocia te s oczywicie bardzo wane)
wymagaj interwencji eksperta.

%prep
%setup -q -n %{name}
%patch0 -p1
%patch1 -p1

find . -type d -name CVS -exec rm -rf "{}" ";" 2> /dev/null || :
find . -type f -name 'Makefile*' -exec sed -i -e 's#^BOOMDIR=.*#BOOMDIR=%{_libdir}/%{name}#g' "{}" ";"

%build
ln -sf %{_includedir}/cppunit include/cppunit
cp -f /usr/share/automake/config.* .
%configure

%if ! %{with flex_bison_c++}
%{__make} remote
%endif

%{__make} \
	C="%{__cc} %{rpmcflags} -I%{_includedir}/gc" \
	CC="%{__cxx} %{rpmcflags} -I%{_includedir}/gc"

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{_bindir},%{_libdir}/%{name}/frontend/machine}

install %{name} $RPM_BUILD_ROOT%{_bindir}
cp -a signatures transformations $RPM_BUILD_ROOT%{_libdir}/%{name}
cp -a frontend/machine/* $RPM_BUILD_ROOT%{_libdir}/%{name}/frontend/machine
find $RPM_BUILD_ROOT%{_libdir}/%{name}/frontend/machine -type f ! -name '*.ssl' -exec rm -f "{}" ";"
cp -a lib $RPM_BUILD_ROOT%{_libdir}/%{name}/lib

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/*
%dir %{_libdir}/%{name}
%dir %{_libdir}/%{name}/lib
%attr(755,root,root) %{_libdir}/%{name}/lib/*.so
%dir %{_libdir}/%{name}/frontend
%dir %{_libdir}/%{name}/frontend/machine
%dir %{_libdir}/%{name}/frontend/machine/*
%{_libdir}/%{name}/frontend/machine/*/*.ssl
%{_libdir}/%{name}/signatures
%{_libdir}/%{name}/transformations

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: boomerang.spec,v $
Revision 1.6  2004/07/11 12:53:26  qboosh
- added types patch (for 64-bit size_t), fixed build on amd64
- clearer files list

Revision 1.5  2004/07/08 21:03:31  arekm
- builds and sometimes works (mostly not)

Revision 1.4  2004/07/08 18:50:09  qboosh
- pl

Revision 1.3  2004/07/07 21:22:14  arekm
- updated

Revision 1.2  2004/07/07 21:05:08  arekm
- looks like they are not using classic flex++

Revision 1.1  2004/07/07 20:32:22  arekm
- initial pld release (still raw and nfy)
